﻿module Game

open System
open System.Timers

//====================================================
// Подробное описание исходника на:
// https://www.interestprograms.ru
// Исходные коды программ и игр
//====================================================

type Game(interval, numrows, numcols) =
    let eraser = Eraser.Rectangle(numrows, numcols)

    let timer =
        new Timer(Interval = interval, Enabled = true)

    let mutable direction = 0

    let checkPos () =
        let eraserpos = eraser.Pos

        for i = 0 to eraser.Right.Length - 1 do
            if eraser.Right[ i ].col = Console.WindowWidth - 1 then
                direction <- 2

        for i = 0 to eraser.Left.Length - 1 do
            if eraser.Left[ i ].col = 0 then
                direction <- 1

        for i = 0 to eraser.Top.Length - 1 do
            if eraser.Top[ i ].row = 0 then
                direction <- 3

        for i = 0 to eraser.Bottom.Length - 1 do
            if eraser.Bottom[ i ].row = Console.WindowHeight then
                direction <- 4


    let timerClick (source: Object) (e: System.Timers.ElapsedEventArgs) : unit =
        eraser.Move direction
        checkPos ()

        // Для надёжного скрытия курсора.
        // При изменении размеров окна курсор вновь появляется.
        Console.CursorVisible <- false

    do timer.Elapsed.AddHandler(timerClick)

    // Методы взаимодействия с пользователем.
    member x.Right() = direction <- 1
    member x.Left() = direction <- 2
    member x.Down() = direction <- 3
    member x.Up() = direction <- 4
